<template>
	<el-dialog title="选择知识" v-model="dialogVisible" draggable append-to-body destroy-on-close>
		<el-form :model="state.queryParams" ref="ruleDialogFormRef" inline @submit.native.prevent :disabled="state.loading">
			<el-form-item label="知识标题" prop="Keyword">
				<el-input v-model="state.queryParams.Keyword" placeholder="知识标题" clearable @keyup.enter="handleQuery" class="keyword-input" />
			</el-form-item>
			<el-form-item>
				<el-button type="primary" @click="handleQuery" :loading="state.loading"> <SvgIcon name="ele-Search" class="mr5" />查询 </el-button>
				<el-button @click="resetQuery(ruleDialogFormRef)" class="default-button"> <SvgIcon name="ele-Refresh" class="mr5" />重置 </el-button>
			</el-form-item>
		</el-form>
		<vxe-table
			border
			:loading="state.loading"
			:data="state.tableData"
			:sort-config="{ remote: true }"
			:column-config="{ resizable: true }"
			:row-config="{ isHover: true, height: 30, keyField: 'id' }"
			ref="tableRef"
			max-height="500px"
			show-overflow
			:scrollY="{ enabled: true, gt: 100 }"
			@radio-change="radioChangeEvent"
			:radio-config="{ highlight: true }"
		>
			>
			<vxe-column type="radio" fixed="left" title="请选择" width="70" align="center"></vxe-column>
			<vxe-column field="title" title="知识标题" min-width="200"></vxe-column>
			<vxe-column field="knowledgeTypeText" title="知识类型"></vxe-column>
			<vxe-column field="creatorOrgName" title="创建部门"></vxe-column>
			<vxe-column field="creationTime" title="创建时间" width="160">
				<template #default="{ row }">
					<span>{{ formatDate(row.creationTime, 'YYYY-mm-dd HH:MM:SS') }}</span>
				</template>
			</vxe-column>
		</vxe-table>
		<pagination
			@pagination="queryList"
			:total="state.total"
			v-model:current-page="state.queryParams.PageIndex"
			v-model:page-size="state.queryParams.PageSize"
			:disabled="state.loading"
		/>
		<template #footer>
			<span class="dialog-footer">
				<el-button @click="dialogVisible = false" class="default-button">取 消</el-button>
				<el-button type="primary" @click="onSubmit" :disabled="!state.tableRadio">保 存</el-button>
			</span>
		</template>
	</el-dialog>
</template>

<script lang="tsx" setup>
import { defineAsyncComponent, reactive, ref } from 'vue';
import { FormInstance } from 'element-plus';
import { formatDate } from '@/utils/formatTime';
import { knowledgeRetrieval } from '@/api/knowledge/retrieval';

const pagination = defineAsyncComponent(() => import('@/components/ProTable/components/Pagination.vue')); // 分页

// 定义子组件向父组件传值/事件
const emit = defineEmits(['choose']);

// 定义变量内容
const state = reactive({
	tableData: [], // 表格数据
	total: 0, // 总条数
	loading: false, // 加载
	queryParams: {
		PageIndex: 1, // 当前页
		PageSize: 10, // 每页条数
		Keyword: null, // 关键字
		RetrievalType: '1', // 标题
	},
	tableRadio: '', // 选择的ID
});
const ruleDialogFormRef = ref<FormInstance>(); // 表单
const dialogVisible = ref(false); // 弹窗

// 打开弹窗
const openDialog = async (row: any) => {
	dialogVisible.value = true;
	try {
		queryList();
		if (row) {
			state.tableRadio = row;
		} else {
			state.tableRadio = '';
		}
	} catch (error) {
		console.log(error);
		state.loading = false;
	}
};
/** 搜索按钮操作 */
const handleQuery = () => {
	state.queryParams.PageIndex = 1;
	queryList();
};
const tableRef = ref<RefType>();
const queryList = () => {
	state.loading = true;
	knowledgeRetrieval(state.queryParams)
		.then((res: any) => {
			state.tableData = res.result?.items ?? [];
			state.total = res.result?.total ?? 0;
			state.loading = false;
			const row = state.tableData.find((item) => item.id === state.tableRadio);
			tableRef.value.setRadioRow(row);
		})
		.catch(() => {
			state.loading = false;
		});
};
const resetQuery = (formEl: FormInstance | undefined) => {
	if (!formEl) return;
	formEl.resetFields();
	state.queryParams.Keyword = null;
	handleQuery();
};

// 关闭弹窗
const closeDialog = () => {
	dialogVisible.value = false;
};
const selectRow = ref<any>(null);
const radioChangeEvent = ({ row }) => {
	state.tableRadio = row.id;
	selectRow.value = row;
};
// 选择知识
const onSubmit = () => {
	emit('choose', selectRow.value);
	closeDialog();
};
//暴漏变量和方法
defineExpose({ closeDialog, openDialog });
</script>
